
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Select与Epoll比较 / 憋错料</title>

    <meta name="description" content="Select与Epoll比较 一.问题引出 联系区别 问题的引出,当需要读两个以上的I/O的时候,如果使用阻塞式的I/O,那么可能长时间的阻塞在一个描述符上面,另外的描述符虽然有数据但是不能读出来,这样实时性不能满足要求,大概的解决方案有以下几种: 1.使用多进程或者多线程,但是这种方法会造成程序的复杂,而且对与进程与线程的创建维护也需要很多的开销.(Apache服务器是用的子进程的方式,优点可以隔离用户) 2.用一个进程,但是使用非阻塞的I/O读取数据,当一个I/O不可读的时候立刻返回,检查下一个是否可读,这种形式的循环为">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Select与Epoll比较</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P>一、问题引出 联系区别</p>
<p>问题的引出，当需要读两个以上的I/O的时候，如果使用阻塞式的I/O，那么可能长时间的阻塞在一个描述符上面，另外的描述符虽然有数据但是不能读出来，这样实时性不能满足要求，大概的解决方案有以下几种：</p>
<p>1.使用多进程或者多线程，但是这种方法会造成程序的复杂，而且对与进程与线程的创建维护也需要很多的开销。（Apache服务器是用的子进程的方式，优点可以隔离用户）</p>
<p>2.用一个进程，但是使用非阻塞的I/O读取数据，当一个I/O不可读的时候立刻返回，检查下一个是否可读，这种形式的循环为轮询（polling），这种方法比较浪费CPU时间，因为大多数时间是不可读，但是仍花费时间不断反复执行read系统调用。</p>
<p>3.异步I/O（asynchronous I/O），当一个描述符准备好的时候用一个信号告诉进程，但是由于信号个数有限，多个描述符时不适用。</p>
<p>4.一种较好的方式为I/O多路转接（I/O<br />
multiplexing）（貌似也翻译多路复用），先构造一张有关描述符的列表（epoll中为队列），然后调用一个函数，直到这些描述符中的一个准备好时才返回，返回时告诉进程哪些I/O就绪。select和epoll这两个机制都是多路I/O机制的解决方案，select为POSIX标准中的，而epoll为Linux所特有的。</p>
<p>区别（epoll相对select优点）主要有三：</p>
<p>1.select的句柄数目受限，在linux/posix_types.h头文件有这样的声明：#define<br />
__FD_SETSIZE&nbsp;&nbsp;&nbsp; 1024&nbsp;<br />
表示select最多同时监听1024个fd。而epoll没有，它的限制是最大的打开文件句柄数目。</p>
<p>2.epoll的最大好处是不会随着FD的数目增长而降低效率，在selec中采用轮询处理，其中的数据结构类似一个数组的数据结构，而epoll是维护一个队列，直接看队列是不是空就可以了。epoll只会对"活跃"的socket进行操作---这是因为在内核实现中epoll是根据每个fd上面的callback函数实现的。那么，只有"活跃"的socket才会主动的去调用<br />
callback函数（把这个句柄加入队列），其他idle状态句柄则不会，在这点上，epoll实现了一个"伪"AIO。但是如果绝大部分的I/O都是“活跃的”，每个I/O端口使用率很高的话，epoll效率不一定比select高（可能是要维护队列复杂）。</p>
<p>3.使用mmap加速内核与用户空间的消息传递。无论是select,poll还是epoll都需要内核把FD消息通知给用户空间，如何避免不必要的内存拷贝就很重要，在这点上，epoll是通过内核于用户空间mmap同一块内存实现的。</p>
<p>二、接口</p>
<p>1）select</p>
<p>1. int select(int maxfdp1, fd_set *restrict readfds, fd_set *restrict<br />
writefds, fd_set *restrict exceptfds, struct timeval *restrict tvptr);</p>
<p>struct timeval{</p>
<p>long tv_sec;</p>
<p>long tv_usec;</p>
<p>}</p>
<p>有三种情况：tvptr == NULL 永远等待；tvptr-&gt;tv_sec == 0 &amp;&amp; tvptr-&gt;tv_usec<br />
== 0<br />
完全不等待；不等于0的时候为等待的时间。select的三个指针都可以为空，这时候select提供了一种比sleep更精确的定时器。注意select的第一个参数maxfdp1并不是描述符的个数，而是最大的描述符加1，一是起限制作用，防止出错，二来可以给内核轮询的时候提供一个上届，提高效率。select返回－1表示出错，0表示超时，返回正值是所有的已经准备好的描述符个数（同一个描述符如果读和写都准备好，对结果影响是+2）。</p>
<p>2.int FD_ISSET(int fd, fd_set *fdset);&nbsp; fd在描述符集合中非0，否则返回0</p>
<p>3.int FD_CLR(int fd, fd_set *fd_set); int FD_SET(int fd, fd_set<br />
*fdset)&nbsp;;int FD_ZERO(fd_set *fdset);</p>
<p>用一段linux 中man里的话“FD_ZERO()&nbsp; clears&nbsp; a set.FD_SET() and&nbsp;<br />
FD_CLR() respectively add and remove a given file descriptor from a set.&nbsp;<br />
FD_ISSET() tests to see if a file descriptor is part of the set; this is useful<br />
after select() returns.”这几个函数与描述符的0和1没关系，只是添加删除检测描述符是否在set中。</p>
<p>2）epoll</p>
<p>1.int epoll_create(int<br />
size);<BR>创建一个epoll的句柄，size用来告诉内核这个监听的数目一共有多大。这个参数不同于select()中的第一个参数，给出最大监听的fd+1的值。需要注意的是，当创建好epoll句柄后，它就是会占用一个fd值，在linux下如果查看/proc/进程id/fd/，是能够看到这个fd的，所以在使用完epoll后，必须调用close()关闭，否则可能导致fd被耗尽。</p>
<p>2. int epoll_ctl(int epfd, int op, int fd, struct epoll_event<br />
*event);<BR>epoll的事件注册函数，它不同与select()是在监听事件时告诉内核要监听什么类型的事件，而是在这里先注册要监听的事件类型。第一个参数是epoll_create()的返回值，第二个参数表示动作，用三个宏来表示：<BR>EPOLL_CTL_ADD：注册新的fd到epfd中；<BR>EPOLL_CTL_MOD：修改已经注册的fd的监听事件；<BR>EPOLL_CTL_DEL：从epfd中删除一个fd；<BR>第三个参数是需要监听的fd，第四个参数是告诉内核需要监听什么事，struct<br />
epoll_event结构如下：<BR>struct epoll_event {<BR>&nbsp; __uint32_t events;&nbsp; /*<br />
Epoll events */<BR>&nbsp; epoll_data_t data;&nbsp; /* User data variable<br />
*/<BR>};</p>
<p>events可以是以下几个宏的集合：<BR>EPOLLIN<br />
：表示对应的文件描述符可以读（包括对端SOCKET正常关闭）；<BR>EPOLLOUT：表示对应的文件描述符可以写；<BR>EPOLLPRI：表示对应的文件描述符有紧急的数据可读（这里应该表示有带外数据到来）；<BR>EPOLLERR：表示对应的文件描述符发生错误；<BR>EPOLLHUP：表示对应的文件描述符被挂断；<BR>EPOLLET：<br />
将EPOLL设为边缘触发(Edge Triggered)模式，这是相对于水平触发(Level<br />
Triggered)来说的。<BR>EPOLLONESHOT：只监听一次事件，当监听完这次事件之后，如果还需要继续监听这个socket的话，需要再次把这个socket加入到EPOLL队列里</p>
<p>关于epoll工作模式ET，LT</p>
<p>LT(level triggered)是缺省的工作方式，并且同时支持block和no-block<br />
socket.在这种做法中，内核告诉你一个文件描述符是否就绪了，然后你可以对这个就绪的fd进行IO操作。如果你不作任何操作，内核还是会继续通知你的，所以，这种模式编程出错误可能性要小一点。传统的select/poll都是这种模型的代表．<BR>ET<br />
(edge-triggered)是高速工作方式，只支持no-block<br />
socket。在这种模式下，当描述符从未就绪变为就绪时，内核通过epoll告诉你。然后它会假设你知道文件描述符已经就绪，并且不会再为那个文件描述符发送更多的就绪通知，直到你做了某些操作导致那个文件描述符不再为就绪状态了，但是请注意，如果一直不对这个fd作IO操作(从而导致它再次变成未就绪)，内核不会发送更多的通知(only<br />
once)</p>
<p>3. int epoll_wait(int epfd, struct epoll_event * events, int maxevents, int<br />
timeout)<BR>等待事件的产生，类似于select()调用。参数events用来从内核得到事件的集合，maxevents告之内核这个events有多大，这个maxevents的值不能大于创建epoll_create()时的size，参数timeout是超时时间（毫秒，0会立即返回，-1永久阻塞）。该函数返回需要处理的事件数目，如返回0表示已超时。</p>
<p>三、参考：</p>
<p>APUE(I/O多路转接)</p>
<p>linux man epoll select</p>
<p><A href="http://www.bubuko.com/infodetail-211922.html" rel="external nofollow noreferrer">Select与Epoll比较,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:50:04 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/int/" title="int">int</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Select与Epoll比较的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5vLv0.html" rel="bookmark">Linux下select&amp;amp&semi;poll&amp;amp&semi;epoll的实现原理（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近简单看了一把Linux linux-3.10.25 kernel中select/poll/epoll这个几个IO事件检测API的实现.此处做一些记录.其基本的原理是相同的,流程如下 先依次调用fd对应的struct file.f_op-&gt;poll()方法(如果有提供实现的话),尝试检查每个提供待检测IO的fd是否已经有IO事件就绪 如果已经有IO事件就绪,则直接所收集到的IO事件返回,本次调用结束 如果暂时没有IO事件就绪,则根据所给定的超时参数,选择性地进入等待 如果超时参数指示不等待,则			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGG2OZM.html" rel="bookmark">I&sol;O多路复用之select&comma;poll&comma;epoll简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.select 1.起源 select最早于1983年出现在4.2BSD中(BSD是早期的UNIX版本的分支). 它通过一个select()系统调用来监视多个文件描述符的数组,当select()返回后,该数组中就绪的文件描述符便会被内核修改标志位,使得进程可以获得这些文件描述符从而进行后续的读写操作. 2.select的优点 目前几乎在所有的平台上支持,具有良好的跨平台支持. 3.select的缺点 单个进程能够监视的文件描述符的数量存在最大限制.默认情况下,在Linux上单个进程能够打开的最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz8VAA3.html" rel="bookmark">select&sol;poll&sol;epoll on serial port</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				In this article, I will use three asynchronous conferencing--select, poll and epoll on serial port to transmit data between PC and Raspberry pi. Outline Character device file of serial port Naive serial communication Asynchronous conferencing Select			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPdo6mM.html" rel="bookmark">转一贴，今天实在写累了，也看累了--【Python异步非阻塞IO多路复用Select&sol;Poll&sol;Epoll使用】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				下面这篇,原理理解了, 再结合 这一周来的心得体会,整个框架就差不多了... http://www.haiyun.me/archives/1056.html 有许多封装好的异步非阻塞IO多路复用框架,底层在linux基于最新的epoll实现,为了更好的使用,了解其底层原理还是有必要的.下面记录下分别基于Select/Poll/Epoll的echo server实现.Python Select Server,可监控事件数量有限制: 1 2 3 4 5 6 7 8 9 10 11 12 13 14			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O7BKg3.html" rel="bookmark">select与epoll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select的api: #include &lt;sys/select.h&gt; #include &lt;sys/time.h&gt; int select(int maxfdp1,fd_set *readset,fd_set *writeset,fd_set *exceptset,const struct timeval *timeout) 返回值:就绪描述符的数目,超时返回0,出错返回-1 epoll的api: #include &lt;sys/epoll.h&gt; int epoll_crea			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38LBKy3.html" rel="bookmark">Linux内核中网络数据包的接收-第二部分 select&sol;poll&sol;epoll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				和前面文章的第一部分一样,这些文字是为了帮别人或者自己理清思路的,而不是所谓的源码分析,想分析源码的,还是直接debug源码最好,看任何文档以及书都是下策.因此这类帮人理清思路的文章尽可能的记成流水的方式,尽可能的简单明了. Linux 2.6+内核的wakeup callback机制 Linux 内核通过睡眠队列来组织所有等待某个事件的task,而wakeup机制则可以异步唤醒整个睡眠队列上的task,每一个睡眠队列上的节点都拥有一个 callback,wakeup逻辑在唤醒睡眠队列时,会遍历			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38w8z20.html" rel="bookmark">中断和轮询 VS  select和epoll</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. select和epoll 首先我们来定义流的概念,一个流可以是文件,socket,pipe等等可以进行I/O操作的内核对象.不管是文件,还是套接字,还是管道,我们都可以把他们看作流. 通过read,我们可以从流中读入数据:通过write,我们可以往流写入数据. 现在假定一个情形,我们需要从流中读数据,但是流中还没有数据,典型的例子为,客户端要从socket读如数据,但是服务器还没有把数据传回来,这时候该怎么办? 阻塞.阻塞是个什么概念呢?比如某个时候你在等快递,但是你不知道快递什么时候过来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ML26Gk3.html" rel="bookmark">编写案例分别使用多进程、多路复用（select、epoll）实现tcp服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				-------------------------------多进程的tcp服务器-------------------------------通过为每个客户创建一个进程的方式,能够同时为多个客户进行服务器当客户不是特别多的时候,这种方式还行,如果有几百上千个,就不可取了,因为每次创建进程等过程需要好较大的资源 python代码案例: 1 #coding=utf-8 2 3 #引用对应的包 4 from socket import * 5 6 from multiprocessing impor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyKPg0.html" rel="bookmark">Linux统系统开发12 Socket API编程3 TCP状态转换 多路IO高并发select  poll  epoll udp组播 线程池</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[本文谢绝转载原文来自http://990487026.blog.51cto.com] Linux统系统开发12 Socket API编程3 TCP状态转换 多路IO高并发select  poll  epoll udp组播 线程池 TCP 11种状态理解: 1,客户端正常发起关闭请求 2,客户端与服务端同时发起关闭请求 3,FIN_WAIT1直接转变TIME_WAIT 4,客户端接收来自服务器的关闭连接请求 多路IO转接服务器: select模型 poll模型 epoll模型 udp组播模型 线			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38Ne1KM.html" rel="bookmark" class="title">Atitit。Tree文件解析器的原理流程与设计实现&amp;&num;160&semi;&amp;&num;160&semi;java&amp;&num;160&semi;&amp;&num;160&semi;c&num;&amp;&num;160&semi;php&amp;&num;160&semi;js</a>
					<div>
						Atitit.Tree文件解析器的原理流程与设计实现  java  c# php js 1. 解析原理与流程1 1.1. 判断目录  ,表示服  dirFlagChar = &quot;└├─&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/412VdYM.html" rel="bookmark" class="title">perl 常用命令</a>
					<div>
						过滤重复字符 [plain] view plaincopy perl -e '$_=&lt;STDIN&gt;; @in = split; if (@in &lt; 100){ @out = grep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jyJngM.html" rel="bookmark" class="title">struts2 在拦截器进行注入（根据Action是否实现自定义接口）</a>
					<div>
						例如:常常在Action中都需要获取当前登录的User,就需要获取Session,然后从Session获取当前登录的User,因为这些步骤都是重复操作,可以想办法在拦截器中进行实现,可以自定义一个接口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGgwa4.html" rel="bookmark" class="title">机器学习笔记（Washington University）- Regression Specialization-week four</a>
					<div>
						1. Ridge regression A way to automatically balance between bias and varaince situations and regulate ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6NEVGM.html" rel="bookmark" class="title">10&period;2解题报告</a>
					<div>
						题目一:栈的优化 原代码:运用函数递归 由于我们知道火车出来的个数与火车总共的个数一定是一样的,所以可以用0 1来表示车辆的出入. 例如:101100 就表示进出进进出出,也就为132. 我们用ruv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvdbk3.html" rel="bookmark" class="title">ios category，protocol理解</a>
					<div>
						category: 向现有的类中增加方法,同时提供方法的实现,现有类不需要做任何改动. protocol:(相当于Java或C#中的接口interface,当很多类都要需要类似的方法,但是方法具体实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaWL7M.html" rel="bookmark" class="title">php如何用window&period;open实现excel数据导出</a>
					<div>
						看前台页面: 开始看控制器页面:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGKypM.html" rel="bookmark" class="title">PHP多次调用Mysql存储过程报错解决办法</a>
					<div>
						PHP多次调用Mysql数据库的存储过程会出现问题,主要问题为存储过程中执行多次SQL语句不能一一释放导致的,网上找了一些解决办法,比如使用 multi_query 然后一个一个释放,但是发现根本不适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEG7v0.html" rel="bookmark" class="title">VMVare9&period;0&comma; Ubuntu12&period;04安装VMWare Tools找不到内核头文件解决方案</a>
					<div>
						VMVare9.2, Ubuntu14.04安装VMWare Tools 遇到一点问题,提示找不到内核头文件,于是baidu之,作如下总结. 首先执行: sudo apt-get install bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLWLqO4.html" rel="bookmark" class="title">java中try  catch块的使用</a>
					<div>
						对于关流操作的时候,最好采用如下语句块: InputStream in=......; try{ try{ //some statemenet }finally{ //close stream in. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDyBBM.html" rel="bookmark" class="title">基于nginx实现protobuf RPC</a>
					<div>
						老婆一起来上海工作,每个月消费立马上来了,做了一个android记账应用,把每笔帐都实时记录进去.开始是单机版的,只能两个人分别记,月底再merge一下.刚好有一台阿里云的ECS,于是准备升级为带服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41577G4.html" rel="bookmark" class="title">Android之操作相册</a>
					<div>
						获取手机中的图片的绝对路径并且区分出每个文件夹下的路径: 存放图片绝对路径的文件夹的名字和存放绝对路径的List 实体类如下: 1 import java.util.ArrayList; 2 impo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvRKe3.html" rel="bookmark" class="title">斐波那契 递推算法</a>
					<div>
						/***Date : 2014.12.10***/ //递推算法:是理性思维模式的代表,根据已有的数据和关系,逐步推导而得出结果. //执行过程:1)根据已知的结果和关系,求解中间结果. ////// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoaeAQ3.html" rel="bookmark" class="title">session&period;createQuery&lpar;&rpar;不执行和java&period;lang&period;reflect&period;InvocationTargetException</a>
					<div>
						今天写SSH的工程的时候,执行到一个DAO中的Query query = session.createQuery(hql)的时候,没有成功执行,直接跳到了finally,然后前台报了500和java. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M65KBN4.html" rel="bookmark" class="title">简易高效的Delphi原子队列</a>
					<div>
						本文提供Delphi一个基于原子操作的无锁队列,简易高效.适用于多线程大吞吐量操作的队列. 可用于Android系统和32,64位Windows系统. 感谢歼10和qsl提供了修改建议! 有如下问题: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wj59Z0.html" rel="bookmark" class="title">BZOJ 4808 二分图最大独立集</a>
					<div>
						思路: 棋盘是个二分图 那就把一个可以走的白点  向所有可以走的黑点连边 跑一个最大匹配   (匹配上了就代表这两个点不能共存) 最大独立集=sum-最大匹配 //By SiriusRen #incl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kokyl0.html" rel="bookmark" class="title">android contentprovider理解</a>
					<div>
						内容提供者用于保存和检索数据,使android系统中不同应用程序之间可以进行共享数据.以uri的形式对外提供数据. 首先用一个类继承android.content包下contentprovide,重写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvjKwM.html" rel="bookmark" class="title">在Maven&plus;Spring项目中使用Node&period;js的Gulp进行前端自动化构建</a>
					<div>
						刚开始打算进行前后端分离开发,后来发现在使用JSP或者Freemarker做动态页面时,想发挥这些自动化构建工具牛逼闪闪的livereload功能并不是那么的轻易,因为我们必须还得调教它们去调用Jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGd1NA0.html" rel="bookmark" class="title">工作中常用到的一些方法集合</a>
					<div>
						1 1.取较大文件,大图 2 NSString *Path = [[NSBundle mainBundle] pathForResource:@&quot;data&quot; ofType:@&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02XrpB4.html" rel="bookmark" class="title">设计模式之策略模式&amp;amp&semi;amp&semi;简单工厂模式</a>
					<div>
						学习设计模式已经有非常长一段时间了,事实上先前已经敲过一遍了.可是老认为没有学到什么,认识也不够深刻.如今趁着重构机房,再又一次来过,也不晚. 事实上在敲了机房之后,看看模式,事实上,曾经非常难理解. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
